<template>

	<v-card>
        <v-card-title>
			Ganti Password
		</v-card-title>

        <v-card-text>

			<v-form
				ref="form"
				v-model="valid"
				lazy-validation>

				<v-text-field
					v-model="email"
					:rules="emailRules"
					label="E-mail"
					required>
				</v-text-field>

				<v-text-field
					v-model="password"
					:rules="passwordRules"
					:append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
            		:type="show1 ? 'text' : 'password'"
					@click:append="show1 = !show1"
					label="Password"
					required>
				</v-text-field>

				<v-text-field
					v-model="password_confirmation"
					:rules="passwordRules"
					:append-icon="show2 ? 'mdi-eye' : 'mdi-eye-off'"
            		:type="show2 ? 'text' : 'password'"
					@click:append="show2 = !show2"
					label="Password Confirmation"
					required>
				</v-text-field>

				<v-btn
					:disabled="!valid"
					color="success"
					class="mr-4"
					@click="validate">
					Submit Password
				</v-btn>

				<v-btn
					color="error"
					class="mr-4"
					@click="reset">
					Reset
				</v-btn>


				<v-snackbar
					v-model="snackbar"
					:vertical="vertical"
					v-bind:color="color"
					>
				
					{{ message }}

					<ul>
						<li v-for="(value,key) in theErrors" v-bind:key="'error-at-'+key">
							{{key}} : {{value}}
						</li>
					</ul>

					<template v-slot:action="{ attrs }">
						<v-btn
							color="indigo"
							text
							v-bind="attrs"
							@click="snackbar = false"
						>
							Close
						</v-btn>
					</template>
				</v-snackbar>

			</v-form>

        </v-card-text>
        
    </v-card>
  	
</template>

<script>

export default {

	data:function(){
		return{
			valid: true,
			email: '',
			emailRules: [
				v => !!v || 'E-mail is required',
				v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
			],
			password: '',
			show1: false,
			passwordRules: [
				v => !!v || 'Password is required',
				v => (v && v.length > 5) || 'Password Must Be Valid!',
			],			
			password_confirmation: '',
			show2: false,			
			message:'',
			theErrors:[],
			snackbar: false,      		
			vertical: true,
			color: 'purple'  		
		}
	},methods:{
		async submit(){
			try {
				 let response = await axios.post('/api/auth/update-password', this.submitPassword())
				 
				 if(response.status == 200){

					let {response_message, response_code} = response.data
					
					this.message = response_message
					this.snackbar = true

					if(response_code=="00"){
						this.color = 'green'
						this.$refs.form.reset()
					}else{
						this.color = 'red'
					}
					

				 }
			} catch (e) {

				console.log(e.response);

				let {e_message, errors} = e.response.data
				this.theErrors = errors
				this.success = errors

				console.log('Error is comming');
				console.log(errors);
				console.log(errors);

				this.message = e_message
				this.snackbar = true
				this.color = 'red'

			}
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()
			if(isSuccessfullyValidated){
				console.log(`the input parameter is: ${this.email}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter is : ${this.email}`)

				this.message = 'Your input is not valid!'
				this.snackbar = true
				this.color = 'red'
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},submitPassword:function(){
			return{
				email:this.email,
				password:this.password,
				password_confirmation:this.password_confirmation
			}
		}		

	},mounted: function(){
		console.log('Regenerate OTP Screen Mounted')
	}
}
</script>

<style>

</style>